      SUBROUTINE BSTMEM( NAME, N, NPROCS, NBMIN,NBMAX, NPRWMIN,NPRWMAX,
     $                   MMIN, OUTFILE, NPRT )
*
      INTEGER         MMIN, N, NPROCS,
     $                NPRWMAX, NPRWMIN, NBMIN, NBMAX, NPRT
*
      CHARACTER*(*)   TRANS, NAME, UPLO
      INTEGER         NOUT, NPR
      PARAMETER       ( NOUT = 12, NPR = 6, TRANS = 'N', UPLO = 'U' )
      CHARACTER       OUTFILE*(*)
*
*  
      INTEGER         INFO, J, NPCOL, NPROW,
     $                NPRC, NPRMAX, NPRMIN, NB,
     $                NMAX, NMIN, MINNB, MAXNB,
     $                MINNPRW, MAXNPRW
*
      INTEGER         NPRE, NPROWPRE, NPCOLPRE, NBPRE,
     $                NFOL, NPROWFOL, NPCOLFOL, NBFOL
*
      INTEGER         MPRE, MFOL, MEM
*
      COMMON           J
*
*  
*
*  
      EXTERNAL          PAR_GESVN
*** PAR_SYEV1N
*
*  
*
      J = 1
*
      NPRC = NPROCS
*
        WRITE( NPR, FMT = 9999 ) NAME
*
*        
*     
*   ( NPROW, NPCOL, NB )   .
*
        OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
*      ,
*     
*
        WRITE( NOUT, FMT = 2007 ) NAME, N, NPRC, NBMIN, NBMAX
*
*      
*
      IF( NPRT .EQ. 0 ) GO TO 1
*
        WRITE( NPR, FMT = 2007 ) NAME, N, NPRC, NBMIN, NBMAX
*
*  
*
    1 IF( NPRWMIN .EQ. 0 ) GO TO 2
       IF( NPRWMIN .EQ. NPRC ) GO TO 32
         MINNPRW = NPRWMIN 
         MAXNPRW = NPRWMAX
         GO TO 3
    2 CONTINUE
*
      MINNPRW = NPRWMIN 
      MAXNPRW = NPRC
*
*   
    3 DO 114 NPRW = MINNPRW, MAXNPRW, 1
*
        IF( MOD(MAXNPRW, NPRW) .NE. 0 ) GO TO 114
        NPROW = NPRW
        NPCOL = INT( FLOAT(NPRC)/FLOAT(NPRW) )
*
*   
*
      IF( NBMIN .EQ. 0 ) GO TO 9
        MINNB = NBMIN
        MAXNB = NBMAX
        GO TO 11
*
    9 CONTINUE
      MINNB = 2
      MAXNB = INT(N/2)
*
   11 DO 112 NB = MINNB, MAXNB, 1
*
        WRITE( NPR, FMT = * ) ' J =', J
*
      IF( NAME .EQ. 'PDGESV' ) GO TO 35
      IF( NAME .EQ. 'PDSYEV1' ) GO TO 36
      GO TO 10
*
   35 CALL PAR_GESVN( NAME, N, NPROW, NPCOL, NB, MMIN, OUTFILE, NPRT )
*
      GO TO 37
*
   36 CONTINUE
**       CALL PAR_SYEV1N( NAME, UPLO, N, NPROW, NPCOL, MMIN,
**     $                NB, VL, VU, IL, IU, ABSTOL, OUTFILE, NPRT )
*
      GO TO 37
*
   37 CONTINUE
*
*     ,   
*     ,   
*      (  )
*   .
*
        MFOL = MMIN
        IF( MPRE .NE. 0.0 ) THEN
          IF( MFOL .GT. MPRE ) THEN
           MPRE = MFOL
           NBPRE = NB
           NPROWPRE = NPROW
           NPCOLPRE = NPCOL
          END IF
        ELSE
          MPRE = MFOL
          NBPRE = NB
          NPROWPRE = NPROW
          NPCOLPRE = NPCOL
        END IF
*
*       , 
*     
*
        IF( NPRT .EQ. 0 ) GO TO 115
*
          WRITE( NPR, FMT = 2003 )NPROW, NPCOL, NB, MMIN
*
  115   J = J + 1
*
  112 CONTINUE
*
  114 CONTINUE
*
*      , 
*   ,  ,     
*    
*
   32 CONTINUE
*
        WRITE( NPR, FMT = 2007 ) NAME, N, NPRC, NBMIN, NBMAX
        WRITE( NPR, FMT = 2001 ) NPROWPRE, NPCOLPRE, NBPRE, MPRE
*      , 
*     ,    
*    
*
        WRITE( NOUT, FMT = 2007 ) NAME, N, NPRC, NBMIN, NBMAX
        WRITE( NOUT, FMT = 2001 ) NPROWPRE, NPCOLPRE, NBPRE, MPRE
*
*        
        CLOSE( NOUT )
*
   10 CONTINUE
*
 2000 FORMAT( /A8,'  N = ',I5,'  NPROCS = ',I3/'   NPROW = ',I3,
     $       '  NPCOL = ',I3,'   NB = ',I3 )
 2001 FORMAT( '     (',I3,','I3,
     $        ' )   NB = ', I3, '  MEM =', I7/ )
 2003 FORMAT(/' NPROW =',I3,' NPCOL =',I3,'   NB =',I3,'  MEM =', I7/)
 2007 FORMAT( /A8,'  N = ',I5,'   NPROCS = ',I3,'  NB(',I3,':',I3,')'/)
*
 9999 FORMAT(/'    , ',
     $        '      ',A8,
     $        '   PARALG'/ )
      RETURN
      END
*
